/* This program contains some data exploration of the New Zealand GDP data
    from the paper "Markov Switching Models for GDP Growth in a Small Open Economy:
    The New Zealand Experience", Buckle, Haugh, and Thompson
    Journal of Business Cycle Measurement and Analysis                                  */

  
new;
library pgraph;
output file=temp.out reset;

/* This looks weird, but it's correct */
dataset="c:NZ_gdp.txt";
load u[26,4] = ^dataset;
u=vecr(u);
u=trimr(u,0,2);

t=rows(u);
m=sumc(u)/t;
v=sumc((u-m)^2)/(t-1); print "Mean and Variance of data"; print m~v;
print; print /flush "Press a key to continue";
wait;

xy(seqa(1,1,rows(u)),u);
wait; 

u=u-meanc(u);
changes=u[2:rows(u)]-u[1:rows(u)-1];
changes2=changes^2;
changes2lag=lag1(changes2);

data=changes2[2:rows(changes2)]~changes2lag[2:rows(changes2)];
data=sortc(data,1);
meanc(data); wait;


_plctrl={-1};
xy(data[.,1],data[.,2]);

{ a,b,c,d } = myols(data[.,1],data[.,2],1,1,"changes"|"sq_chng");
end;

