/* This program takes the simulated data which has
   been saved (filenam1) and the actual data (dataset)
   and does the following:

   1) Conducts moment test of mean and variance;
   2) Conducts moment test of p1 and p2;
        All moments test are printed to an output file 
        called c:\mstests.out
   3) Compares simulated densities to data and prints
      output to "out.dat";
   4) Creates nonparametric regression estimates 
      of E[y(t),y(t-1)] from
      simulated data--output to "out1.dat";
   5) Creates nonparametric regression estimates 
      of E[y(t),y(t-2)] from
      simulated data--output to "out2.dat";
   
                                             */

new;
#include c:mstest; 
library pgraph,optmum;
filenam1="c:simdata0";
open f1=^filenam1 for read;
y=readr(f1,100000);
dataset="c:nz_gdp.txt";
load r[26,4] = ^dataset;
r=vecr(r);
r=trimr(r,0,2);


@ OUTPUT FILE @

output file=c:\mstests.out reset;

@ MOMENT TESTS @

model1="AR(0)";
model2="AR(1)";
model3="MS(0)--Hamilton";
model4="MS(22)";
model5="MS(32)";

mstest0(meanc(y[.,1]),stdc(y[.,1])^2,r,dataset,model1);
mstest1(r,y[.,1],dataset,model1); 
mstest7(r,y[.,1],dataset,model1);
mstest8(r,y[.,1],dataset,model1);
mstest0(meanc(y[.,2]),stdc(y[.,2])^2,r,dataset,model2);
mstest1(r,y[.,2],dataset,model2); 
mstest7(r,y[.,2],dataset,model2);
mstest8(r,y[.,2],dataset,model2);
mstest0(meanc(y[.,3]),stdc(y[.,3])^2,r,dataset,model3);
mstest1(r,y[.,3],dataset,model3); 
mstest7(r,y[.,3],dataset,model3);
mstest8(r,y[.,3],dataset,model3);
mstest0(meanc(y[.,4]),stdc(y[.,4])^2,r,dataset,model4);
mstest1(r,y[.,4],dataset,model4); 
mstest7(r,y[.,4],dataset,model4);
mstest8(r,y[.,4],dataset,model4);
mstest0(meanc(y[.,5]),stdc(y[.,5])^2,r,dataset,model5);
mstest1(r,y[.,5],dataset,model5); 
mstest7(r,y[.,5],dataset,model5);
mstest8(r,y[.,5],dataset,model5);

output off;

end;


