new;
#include c:\mstest; 
library pgraph,optmum;
filenam1="c:\simdata0";
open f1=^filenam1 for read;
y=readr(f1,100000);

/* y has 5 columns representing
    1) AR(0) model
    2) AR(1) model
    3) Their estimates of simple MS model (Hamilton)
    4) Their model 2-2
    5) Their model 3-2
(see page 243 of the paper for parameter estimates                */

dataset="c:nz_gdp.txt";
load r[26,4] = ^dataset;
r=vecr(r);
r=trimr(r,0,2);

h=opthcvd1(r);
n=rows(r);

print "This is the bandwidth used.";
print "This is chosen by leave-one-out ";;
print "cross-validation on the data.";
print h;

/* all of these return nx4 matrices 
    col1: sorted data points
    col2: density estimates
    col3: lower pointwise confidence bands
    col4: upper pointwise confidence bands  */

z1=densest1(r,h);
{h,z2}=densest2(y[.,1],r,0,0);
{h,z3}=densest2(y[.,2],r,0,0);
{h,z4}=densest2(y[.,3],r,0,0);
{h,z5}=densest2(y[.,4],r,0,0);
{h,z6}=densest2(y[.,5],r,0,0);


/* Note that Ehatm and Vhatm both depend only upon 
    the kernel used (standard normal in this case)
    and the density estimate of the data */

ehatm=(.5/sqrt(pi))*sumc(z1[.,2])/rows(z1);
print "ehtam" ehatm;
vhatm=2*(.5/sqrt(2*pi))*sumc(z1[.,2]^4)/rows(z1);
print "vhatm" vhatm;
mhatcrit=ehatm+sqrt(h)*1.96*sqrt(vhatm);
print "mhatcrit--95%" mhatcrit;
temp=ehatm+sqrt(h)*1.645*sqrt(vhatm);
print "mhatcrit--90%" temp;

/* First we run the M-hat test for the AR(4) model */

mhatmod1=h*sumc((z1[.,2]-z2[.,2])^2);
mhatmod2=h*sumc((z1[.,2]-z3[.,2])^2);
mhatmod3=h*sumc((z1[.,2]-z4[.,2])^2);
mhatmod4=h*sumc((z1[.,2]-z5[.,2])^2);
mhatmod5=h*sumc((z1[.,2]-z6[.,2])^2);

print "Critical value";
print mhatcrit;
print "test for AR(0)";
print mhatmod1;
print "test for AR(1)";
print mhatmod2;
print "test for MS(0)";
print mhatmod3;
print "test for MS(2-2)";
print mhatmod4;
print "test for MS(3-2)";
print mhatmod5;

end;